﻿package 
{
	import adobe.utils.CustomActions;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	/**
	$(CBI)* ...
	$(CBI)* @author Guchan Alkan
	$(CBI)*/
	public class Main extends Sprite 
	{
		private var spr:Sprite;
		
		private const learningRate:Number = .1;
		private const threshold:Number = .5;
		
		private var weight11:Number = .1;
		private var weight12:Number = .1;
		
		private var correct:Boolean;
		private var sum:Number;
		private var output:uint;
		
		private var buttonArray:Array = new Array();
		private var labelArray:Array = ["reset", "train"];
		private var button:Button;
		
		private var neuronArray:Array = new Array();
		private var inputNeuron1:Neuron = new Neuron(true);
		private var inputNeuron2:Neuron = new Neuron(true);
		private var outputNeuron:Neuron = new Neuron(false);
		
		private var desiredTxt:TxtFld = new TxtFld("Desired Value =", true);
		private var dataTxt:TxtFld = new TxtFld("input1 = " + 0 + "\n" + "input2 = " + 0 + "\n" + "weight1.1 = " + weight11 + "\n" + "weight1.2 = " + weight12 + "\n" + "sum = " + 0 + "\n" + "decision = " + correct, false);
		private var inputTxt:TxtFld = new TxtFld("|input layer|");
		private var outputTxt:TxtFld = new TxtFld("|output layer|");
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			spr = new Sprite();
			spr.graphics.beginFill(0x000000, .2);
			spr.graphics.drawRect(100, 0, 250, 200);
			spr.graphics.endFill();
			addChild(spr);
			
			for (var i:uint = 0; i < 2; i++)
			{
				button = new Button(labelArray[i], i);
				addChild(button);
				button.x = i * 50;
				button.y = 151;
				button.addEventListener(MouseEvent.CLICK, clickButton);
				buttonArray.push(button);
			}
			
			addChild(desiredTxt);
			desiredTxt.x = 150;
			
			addChild(dataTxt);
			dataTxt.y = 30;
			
			addChild(inputTxt);
			inputTxt.x = 136;
			inputTxt.y = 180;
			addChild(outputTxt);
			outputTxt.x = 242;
			outputTxt.y = 130;
			
			addChild(inputNeuron1);
			inputNeuron1.x = 170; inputNeuron1.y = 50;
			addChild(inputNeuron2);
			inputNeuron2.x = 170; inputNeuron2.y = 150;
			addChild(outputNeuron);
			outputNeuron.x = 280; outputNeuron.y = 100;
			
			inputNeuron1.graphics.lineStyle(2, 0x000000);
			inputNeuron1.graphics.lineTo(100, 50);
			
			inputNeuron2.graphics.lineStyle(2, 0x000000);
			inputNeuron2.graphics.lineTo(100, -50);
		}
		
		private function clickButton(e:MouseEvent):void
		{
			if (e.target.name == 1)
			{
				calc(int(inputNeuron1.txt.text), int(inputNeuron2.txt.text), int(desiredTxt.dynamicTxt.text));
			}
			else
			{
				weight11 = weight12 = 0.1;
				calc(int(inputNeuron1.txt.text), int(inputNeuron2.txt.text), int(desiredTxt.dynamicTxt.text));
			}
		}
		
		private function calc(input1:uint, input2:uint, desired:uint):void
		{
			if (input1 < 2 && input2 < 2 && desired < 2)
			{
				sum = input1 * weight11 + input2 * weight12;
				if (sum > threshold)
				{
					output = 1;
					outputNeuron.giveOutput(output);
					if (output == desired)
					{
						correct = true;
					}
					else
					{
						correct = false;
					}
				}
				else
				{
					output = 0;
					outputNeuron.giveOutput(output);
					if (output == desired)
					{
						correct = true;
					}
					else
					{
						correct = false;
					}
				}
				dataTxt.setTxt("input1 = " + input1 + "\n" + "input2 = " + input2 + "\n" + "weight1.1 = " + weight11 + "\n" + "weight1.2 = " + weight12 + "\n" + "sum = " + sum + "\n" + "decision = " + correct);
				if (!correct)
				{
					if (input1 > 0)
					{
						weight11 += (desired - output) * learningRate;
						weight11 = (Math.floor(weight11 * 10)) / 10;
					}
					if (input2 > 0)
					{
						weight12 += (desired - output) * learningRate;
						weight12 = (Math.floor(weight12 * 10)) / 10;
					}
				}
			}
			else
			{
				dataTxt.setTxt("The input values and desired value can only be '0' or '1'.");
			}
		}
		
	}
	
}